local addonName = "Bartender4"

cyCircled_Bartender4 = cyCircled:NewModule(addonName)

local _G = getfenv(0)

function cyCircled_Bartender4:AddonLoaded(addon)
	self.db = cyCircled:AcquireDBNamespace(addonName)
	
	-- setup default config and element table (10 bars)
	local bid, bname = 0, ""
	self.defaultCfg = {}
	self.elements = {}
	self.buttonmap = {}
	for i=1, 10 do
		self.defaultCfg[tostring(i)] = true
		
		-- bars
		self.elements[tostring(i)] = { 
			elements = {},
			args = {
				parentname = false,
			},
		}
		
		-- buttons (12 buttons per bar)
		bid = (i-1)*12
		for j=(bid+1), (bid+12) do
			bname = format("BT4Button%d", j)
			if _G[bname] then bname = _G[bname]:GetName() end
			table.insert(self.elements[tostring(i)].elements, bname)
			
			--  button to bar map (to easily check if a bar has the skin enabled)
			self.buttonmap[j] = i
		end
	end
	self.defaultCfg["Stance"] = true
	self.elements["Stance"] = { 
			elements = {},
			args = {
				parentname = false,
			},
		}
	for i=1, 10 do
		table.insert(self.elements["Stance"].elements, format("BT4StanceButton%d", i))
	end
	self.defaultCfg["Pet"] = true
	self.elements["Pet"] = { 
			elements = {},
			args = {
				parentname = false,
			},
		}
	for i=1, 10 do
		table.insert(self.elements["Pet"].elements, format("BT4PetButton%d", i))
	end
	--[[-- bags
	self.defaultCfg["BarBAGS"] = true
	self.elements["BarBAGS"] = { 
			elements = {},
			alias = { icon = "IconTexture" },
			args = {
				button = { width = 35, height = 35 },
				hotkey = false,
				count = false,
				eborder = false,
				ft = false,
				cooldown = false,
				parentname = false,
			},
		}
	table.insert(self.elements["BarBAGS"].elements, "CharacterBag3Slot")
	table.insert(self.elements["BarBAGS"].elements, "CharacterBag2Slot")
	table.insert(self.elements["BarBAGS"].elements, "CharacterBag1Slot")
	table.insert(self.elements["BarBAGS"].elements, "CharacterBag0Slot")
	table.insert(self.elements["BarBAGS"].elements, "MainMenuBarBackpackButton")
	]]
	cyCircled:RegisterDefaults(addonName, "profile", self.defaultCfg)
	
	-- equipped item hack
	self:Hook(Bartender4.Button.prototype, "Update", "UpdateEquip")
end

function cyCircled_Bartender4:UpdateEquip(button, ...)
	self.hooks[Bartender4.Button.prototype].Update(button, ...)
	cyCircled:UpdateEquipState(button.action, "BT4Button"..button.id)
end

function cyCircled_Bartender4:GetElements()
	return {
		["1"] = true,
		["2"] = true,
		["3"] = true,
		["4"] = true,
		["5"] = true,
		["6"] = true,
		["7"] = true,
		["8"] = true,
		["9"] = true,
		["10"] = true,
		["Stance"] = "Stance Bar",
		["Pet"] = "Pet Bar",
		--["BarBAGS"] = "Bag Bar",
	}
end
